"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var browserUtils_1 = require("./browserUtils");
var device_1 = require("./device");
var logger_1 = require("../logger");
var pageUtils_1 = require("./pageUtils");
var RequestTracker_1 = require("./RequestTracker");
var runStep_1 = require("./runStep");
var timer_1 = require("../timer");
var Browser = (function () {
    function Browser() {
        this._currentPageIndex = 0;
        this._pages = [];
        this._requests = new RequestTracker_1.RequestTracker();
    }
    Browser.create = function (options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var self, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        logger_1.logger.debug("Browser: create " + JSON.stringify(options));
                        self = new Browser();
                        self._device = device_1.getDevice(options.size);
                        _a = self;
                        return [4, browserUtils_1.launchPuppeteerBrowser(self._device)];
                    case 1:
                        _a._browser = _b.sent();
                        return [4, self.managePages()];
                    case 2:
                        _b.sent();
                        if (!options.url) return [3, 4];
                        return [4, self.goto(options.url)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4: return [2, self];
                }
            });
        });
    };
    Browser.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._browser.close()];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    Browser.prototype.currentPage = function () {
        return this.waitForPage(this._currentPageIndex);
    };
    Browser.prototype.goto = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var page;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.currentPage()];
                    case 1:
                        page = _a.sent();
                        return [4, page.goto(url)];
                    case 2:
                        _a.sent();
                        return [2, page];
                }
            });
        });
    };
    Browser.prototype.runStep = function (step) {
        return __awaiter(this, void 0, void 0, function () {
            var page;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.waitForPage(step.pageId)];
                    case 1:
                        page = _a.sent();
                        return [4, this._requests.waitUntilComplete(page)];
                    case 2:
                        _a.sent();
                        return [2, runStep_1.runStep(page, step)];
                }
            });
        });
    };
    Browser.prototype.waitForPage = function (index, timeoutMs) {
        if (index === void 0) { index = 0; }
        if (timeoutMs === void 0) { timeoutMs = 5000; }
        return __awaiter(this, void 0, void 0, function () {
            var i, page;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger_1.logger.debug("Browser: waitForPage(" + index + ")");
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < timeoutMs / 100 && index >= this._pages.length)) return [3, 4];
                        return [4, timer_1.sleep(100)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3, 1];
                    case 4:
                        if (index >= this._pages.length) {
                            throw new Error("Browser: waitForPage(" + index + ") timed out");
                        }
                        page = this._pages[index];
                        this._currentPageIndex = index;
                        return [4, page.bringToFront()];
                    case 5:
                        _a.sent();
                        logger_1.logger.debug("Browser: waitForPage(" + index + ") activated " + page.url());
                        return [2, page];
                }
            });
        });
    };
    Browser.prototype.managePage = function (page) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, pageUtils_1.injectWebBundle(page)];
                    case 1:
                        _a.sent();
                        return [4, page.emulate(this._device)];
                    case 2:
                        _a.sent();
                        this._requests.track(page);
                        this._pages.push(page);
                        return [2];
                }
            });
        });
    };
    Browser.prototype.managePages = function () {
        return __awaiter(this, void 0, void 0, function () {
            var pages;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this._browser.pages()];
                    case 1:
                        pages = _a.sent();
                        if (pages.length !== 1) {
                            throw new Error("Must managePages before opening pages");
                        }
                        return [4, this.managePage(pages[0])];
                    case 2:
                        _a.sent();
                        this._browser.on("targetcreated", function (target) { return __awaiter(_this, void 0, void 0, function () {
                            var page;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4, target.page()];
                                    case 1:
                                        page = _a.sent();
                                        if (page)
                                            this.managePage(page);
                                        return [2];
                                }
                            });
                        }); });
                        return [2];
                }
            });
        });
    };
    return Browser;
}());
exports.Browser = Browser;
//# sourceMappingURL=Browser.js.map