"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var logger_1 = require("../logger");
var RequestTracker = (function () {
    function RequestTracker(timeout) {
        if (timeout === void 0) { timeout = 10000; }
        this._trackers = [];
        this._timeout = timeout;
    }
    RequestTracker.prototype.track = function (page) {
        var _this = this;
        var tracker = {
            page: page,
            requests: [],
            onComplete: []
        };
        this._trackers.push(tracker);
        var removeRequest = function (request, reason) {
            var items = lodash_1.remove(tracker.requests, function (i) { return i === request; });
            if (items.length < 1)
                return;
            logger_1.logger.verbose("RequestTracker: request-- " + reason + " " + tracker.requests.length + " " + page.url());
            if (tracker.requests.length === 0) {
                tracker.onComplete.forEach(function (done) { return done(); });
                tracker.onComplete = [];
            }
        };
        page.on("request", function (request) {
            tracker.requests.push(request);
            logger_1.logger.verbose("RequestTracker: request++ " + tracker.requests.length + " " + page.url());
            setTimeout(function () { return removeRequest(request, "timeout"); }, _this._timeout);
        });
        page.on("requestfailed", function (request) {
            return removeRequest(request, "requestfailed");
        });
        page.on("requestfinished", function (request) {
            return removeRequest(request, "requestfinished");
        });
    };
    RequestTracker.prototype.waitUntilComplete = function (page) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                logger_1.logger.debug("RequestTracker: waitUntilComplete " + page.url());
                return [2, new Promise(function (resolve) {
                        var tracker = _this._trackers.find(function (c) { return c.page === page; });
                        if (!tracker)
                            throw new Error("Cannot find counter. Page is not tracked");
                        if (tracker.requests.length === 0) {
                            logger_1.logger.debug("RequestTracker: waitUntilComplete resolved immediately " + page.url());
                            resolve();
                            return;
                        }
                        tracker.onComplete.push(resolve);
                    })];
            });
        });
    };
    return RequestTracker;
}());
exports.RequestTracker = RequestTracker;
//# sourceMappingURL=RequestTracker.js.map