"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var puppeteer_1 = require("puppeteer");
exports.getDevice = function (size) {
    if (size === void 0) { size = "desktop"; }
    if (size === "desktop") {
        return {
            name: "Desktop",
            userAgent: "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.90 Safari/537.36",
            viewport: {
                width: 1366,
                height: 768,
                deviceScaleFactor: 1,
                isMobile: false,
                hasTouch: false,
                isLandscape: false
            }
        };
    }
    if (size === "tablet") {
        return puppeteer_1.devices["iPad"];
    }
    else if (size === "mobile") {
        return puppeteer_1.devices["iPhone 7"];
    }
    throw new Error("invalid size " + size);
};
//# sourceMappingURL=device.js.map