"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var config_1 = require("../config");
var logger_1 = require("../logger");
var pageUtils_1 = require("./pageUtils");
exports.findElementForStep = function (page, step) { return __awaiter(void 0, void 0, void 0, function () {
    var jsHandle, handle;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, page.evaluateHandle(function (waitForArgs) {
                    var qawolf = window.qawolf;
                    return qawolf.locate.waitForElement(waitForArgs);
                }, {
                    action: step.action,
                    dataAttribute: config_1.CONFIG.dataAttribute,
                    target: step.target,
                    timeoutMs: 30000
                })];
            case 1:
                jsHandle = _a.sent();
                handle = jsHandle.asElement();
                if (!handle) {
                    throw new Error("No element handle found for step " + step);
                }
                return [2, handle];
        }
    });
}); };
exports.inputStep = function (page, elementHandle, step) { return __awaiter(void 0, void 0, void 0, function () {
    var handleProperty, tagName, value;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, elementHandle.getProperty("tagName")];
            case 1:
                handleProperty = _a.sent();
                return [4, handleProperty.jsonValue()];
            case 2:
                tagName = _a.sent();
                value = step.value || "";
                if (!(tagName.toLowerCase() === "select")) return [3, 4];
                return [4, elementHandle.select(value)];
            case 3:
                _a.sent();
                return [3, 7];
            case 4: return [4, page.evaluate(function (element) {
                    element.value = "";
                }, elementHandle)];
            case 5:
                _a.sent();
                return [4, elementHandle.type(value)];
            case 6:
                _a.sent();
                _a.label = 7;
            case 7: return [2];
        }
    });
}); };
exports.scrollStep = function (page, step) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, page.evaluate(function (step) {
                    var qawolf = window.qawolf;
                    return qawolf.actions.scrollTo(step.scrollTo);
                }, step)];
            case 1:
                _a.sent();
                return [2];
        }
    });
}); };
exports.runStep = function (page, step) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                logger_1.logger.debug("running step: " + JSON.stringify(step));
                return [4, pageUtils_1.retryAsync(function () { return __awaiter(void 0, void 0, void 0, function () {
                        var elementHandle;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (step.action === "scroll") {
                                        return [2, exports.scrollStep(page, step)];
                                    }
                                    return [4, exports.findElementForStep(page, step)];
                                case 1:
                                    elementHandle = _a.sent();
                                    if (step.action === "click") {
                                        return [2, elementHandle.click()];
                                    }
                                    if (step.action === "input") {
                                        return [2, exports.inputStep(page, elementHandle, step)];
                                    }
                                    throw new Error("step action not supported: " + step.action);
                            }
                        });
                    }); })];
            case 1: return [2, _a.sent()];
        }
    });
}); };
//# sourceMappingURL=runStep.js.map