"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var clear_1 = __importDefault(require("clear"));
var commander_1 = __importDefault(require("commander"));
var fs_extra_1 = __importStar(require("fs-extra"));
var lodash_1 = require("lodash");
var path_1 = require("path");
var buildJob_1 = require("./build/buildJob");
var buildTest_1 = require("./build/buildTest");
var config_1 = require("./config");
var logger_1 = require("./logger");
var runTest_1 = require("./runTest");
clear_1.default();
commander_1.default
    .command("build <eventsPath> <name>")
    .description("build a test from events")
    .action(function (eventsPath, name) { return __awaiter(void 0, void 0, void 0, function () {
    var sourcePath, formattedName, destPath, events, job, test;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                sourcePath = path_1.resolve(eventsPath);
                formattedName = lodash_1.snakeCase(name);
                destPath = process.cwd() + "/.qawolf/__tests__/" + formattedName + ".js";
                logger_1.logger.debug("build test for " + sourcePath + " -> " + destPath);
                return [4, fs_extra_1.default.readJson(sourcePath)];
            case 1:
                events = _a.sent();
                job = buildJob_1.buildJob(events, formattedName);
                test = buildTest_1.buildTest(job, config_1.CONFIG.useLocalModule);
                return [4, fs_extra_1.outputFile(destPath, test, "utf8")];
            case 2:
                _a.sent();
                process.exit(0);
                return [2];
        }
    });
}); });
commander_1.default
    .command("run [name]")
    .description("run a test")
    .action(function (name) { return __awaiter(void 0, void 0, void 0, function () {
    var success;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, runTest_1.runTest(name ? lodash_1.snakeCase(name) : undefined)];
            case 1:
                success = _a.sent();
                process.exit(success ? 0 : 1);
                return [2];
        }
    });
}); });
commander_1.default.allowUnknownOption(false);
commander_1.default.parse(process.argv);
if (!process.argv.slice(2).length) {
    console.log("\n");
    commander_1.default.outputHelp();
}
//# sourceMappingURL=cli.js.map