"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var winston_1 = __importDefault(require("winston"));
var config_1 = require("./config");
var transports = [];
if (config_1.CONFIG.logPath) {
    transports.push(new winston_1.default.transports.File({
        filename: config_1.CONFIG.logPath + "/" + Date.now() + ".log",
        level: "debug"
    }));
}
else {
    transports.push(new winston_1.default.transports.Console({ level: "error" }));
}
exports.logger = winston_1.default.createLogger({
    transports: transports
});
//# sourceMappingURL=logger.js.map