"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Browser_1 = require("../browser/Browser");
var config_1 = require("../config");
var browser;
var page;
beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, Browser_1.Browser.create({ url: config_1.CONFIG.testUrl + "login" })];
            case 1:
                browser = _a.sent();
                return [4, browser.currentPage()];
            case 2:
                page = _a.sent();
                return [2];
        }
    });
}); });
afterAll(function () { return browser.close(); });
describe("isVisible", function () {
    test("returns true if element visible", function () { return __awaiter(void 0, void 0, void 0, function () {
        var isElementVisible;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        return qawolf.locate.isVisible(username);
                    })];
                case 1:
                    isElementVisible = _a.sent();
                    expect(isElementVisible).toBe(true);
                    return [2];
            }
        });
    }); });
    test("returns false if element has no width", function () { return __awaiter(void 0, void 0, void 0, function () {
        var isElementVisible;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        username.style.border = "0";
                        username.style.padding = "0";
                        username.style.width = "0";
                        return qawolf.locate.isVisible(username);
                    })];
                case 1:
                    isElementVisible = _a.sent();
                    expect(isElementVisible).toBe(false);
                    return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
describe("queryActionElements", function () {
    test("returns all elements for click action", function () { return __awaiter(void 0, void 0, void 0, function () {
        var actionElementCount;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var actionElements = qawolf.locate.queryActionElements("click");
                        return actionElements.length;
                    })];
                case 1:
                    actionElementCount = _a.sent();
                    expect(actionElementCount).toBe(28);
                    return [2];
            }
        });
    }); });
    test("returns only input elements for input action", function () { return __awaiter(void 0, void 0, void 0, function () {
        var actionElements;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var actionElements = qawolf.locate.queryActionElements("input");
                        return actionElements.map(function (el) { return qawolf.xpath.getXpath(el); });
                    })];
                case 1:
                    actionElements = _a.sent();
                    expect(actionElements).toEqual([
                        "//*[@id='username']",
                        "//*[@id='password']"
                    ]);
                    return [2];
            }
        });
    }); });
    test("does not include elements that are not visible", function () { return __awaiter(void 0, void 0, void 0, function () {
        var actionElementXpaths;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        username.style.border = "0";
                        username.style.padding = "0";
                        username.style.width = "0";
                        var actionElements = qawolf.locate.queryActionElements("input");
                        return actionElements.map(function (el) { return qawolf.xpath.getXpath(el); });
                    })];
                case 1:
                    actionElementXpaths = _a.sent();
                    expect(actionElementXpaths).toEqual(["//*[@id='password']"]);
                    return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
describe("queryDataElements", function () {
    test("returns all elements with given data value for click action", function () { return __awaiter(void 0, void 0, void 0, function () {
        var dataElementXpaths;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var submit = document.getElementsByTagName("button")[0];
                        submit.setAttribute("data-qa", "submit");
                        var dataElements = qawolf.locate.queryDataElements({
                            action: "click",
                            dataAttribute: "data-qa",
                            dataValue: "submit"
                        });
                        submit.removeAttribute("data-qa");
                        return dataElements.map(function (el) { return qawolf.xpath.getXpath(el); });
                    })];
                case 1:
                    dataElementXpaths = _a.sent();
                    expect(dataElementXpaths).toEqual(["//*[@id='login']/button"]);
                    return [2];
            }
        });
    }); });
    test("returns only input elements with given data value for input action", function () { return __awaiter(void 0, void 0, void 0, function () {
        var dataElementXpaths;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        var submit = document.getElementsByTagName("button")[0];
                        username.setAttribute("data-qa", "username");
                        submit.setAttribute("data-qa", "username");
                        var dataElements = qawolf.locate.queryDataElements({
                            action: "input",
                            dataAttribute: "data-qa",
                            dataValue: "username"
                        });
                        username.removeAttribute("data-qa");
                        submit.removeAttribute("data-qa");
                        return dataElements.map(function (el) { return qawolf.xpath.getXpath(el); });
                    })];
                case 1:
                    dataElementXpaths = _a.sent();
                    expect(dataElementXpaths).toEqual(["//*[@id='username']"]);
                    return [2];
            }
        });
    }); });
    test("does not include elements that are not visible", function () { return __awaiter(void 0, void 0, void 0, function () {
        var dataElementXpaths;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        var password = document.getElementById("password");
                        username.style.border = "0";
                        username.style.padding = "0";
                        username.style.width = "0";
                        username.setAttribute("data-qa", "username");
                        password.setAttribute("data-qa", "username");
                        var dataElements = qawolf.locate.queryDataElements({
                            action: "input",
                            dataAttribute: "data-qa",
                            dataValue: "username"
                        });
                        return dataElements.map(function (el) { return qawolf.xpath.getXpath(el); });
                    })];
                case 1:
                    dataElementXpaths = _a.sent();
                    expect(dataElementXpaths).toEqual(["//*[@id='password']"]);
                    return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
describe("queryVisibleElements", function () {
    test("returns only visible elements for a given selector", function () { return __awaiter(void 0, void 0, void 0, function () {
        var visibleElementXpaths;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        username.style.border = "0";
                        username.style.padding = "0";
                        username.style.width = "0";
                        var actionElements = qawolf.locate.queryVisibleElements("input");
                        return actionElements.map(function (el) { return qawolf.xpath.getXpath(el); });
                    })];
                case 1:
                    visibleElementXpaths = _a.sent();
                    expect(visibleElementXpaths).toEqual(["//*[@id='password']"]);
                    return [4, browser.goto(config_1.CONFIG.testUrl + "login")];
                case 2:
                    _a.sent();
                    return [2];
            }
        });
    }); });
});
describe("waitForElement", function () {
    test("returns top element by data attribute if specified", function () { return __awaiter(void 0, void 0, void 0, function () {
        var elementXpath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        var submit = document.getElementsByTagName("button")[0];
                        username.setAttribute("data-qa", "username");
                        submit.setAttribute("data-qa", "username");
                        return qawolf.locate
                            .waitForElement({
                            action: "input",
                            dataAttribute: "data-qa",
                            target: { dataValue: "username" },
                            timeoutMs: 5000
                        })
                            .then(function (element) {
                            username.removeAttribute("data-qa");
                            submit.removeAttribute("data-qa");
                            return qawolf.xpath.getXpath(element);
                        });
                    })];
                case 1:
                    elementXpath = _a.sent();
                    expect(elementXpath).toBe("//*[@id='username']");
                    return [2];
            }
        });
    }); });
    test("returns top element by strong attribute if specified", function () { return __awaiter(void 0, void 0, void 0, function () {
        var elementXpath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        var submit = document.getElementsByTagName("button")[0];
                        username.setAttribute("data-qa", "username");
                        submit.setAttribute("data-qa", "username");
                        return qawolf.locate
                            .waitForElement({
                            action: "input",
                            dataAttribute: "data-qa",
                            target: { id: "username" },
                            timeoutMs: 5000
                        })
                            .then(function (element) {
                            username.removeAttribute("data-qa");
                            submit.removeAttribute("data-qa");
                            return qawolf.xpath.getXpath(element);
                        });
                    })];
                case 1:
                    elementXpath = _a.sent();
                    expect(elementXpath).toBe("//*[@id='username']");
                    return [2];
            }
        });
    }); });
    test("returns best weak match if no strong matches found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var elementXpath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        return qawolf.locate
                            .waitForElement({
                            action: "click",
                            dataAttribute: null,
                            target: { tagName: "button" },
                            timeoutMs: 2000
                        })
                            .then(function (element) {
                            return qawolf.xpath.getXpath(element);
                        });
                    })];
                case 1:
                    elementXpath = _a.sent();
                    expect(elementXpath).toBe("//*[@id='login']/button");
                    return [2];
            }
        });
    }); });
    test("returns null if no test found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var elementXpath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        return qawolf.locate
                            .waitForElement({
                            action: "input",
                            dataAttribute: null,
                            target: { labels: ["dropdown"], tagName: "select" },
                            timeoutMs: 2000
                        })
                            .then(function (element) {
                            if (!element)
                                return null;
                            return qawolf.xpath.getXpath(element);
                        });
                    })];
                case 1:
                    elementXpath = _a.sent();
                    expect(elementXpath).toBeNull();
                    return [2];
            }
        });
    }); });
});
//# sourceMappingURL=locate.test.js.map