"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var Locator = (function () {
    function Locator(_a) {
        var dataAttribute = _a.dataAttribute, elementMetadata = _a.elementMetadata;
        this.dataAttribute = dataAttribute;
        this.elementMetadata = elementMetadata;
    }
    Locator.prototype.findEligible = function () {
        throw new Error("findEligible must be implemented by Locator subclass");
    };
    Locator.prototype.findIdeal = function () {
        throw new Error("findIdeal must be implemented by Locator subclass");
    };
    Locator.prototype.findByDataAttribute = function () {
        var selector = "[" + this.dataAttribute + "='" + this.elementMetadata.dataValue + "']";
        var elements = utils_1.queryVisible(selector);
        if (elements.length > 1) {
            throw new Error("Can't decide: found " + elements.length + " elements with data attribute " + selector);
        }
        return elements.length ? [elements[0]] : [];
    };
    return Locator;
}());
exports.Locator = Locator;
//# sourceMappingURL=Locator.js.map