"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Browser_1 = require("../browser/Browser");
var config_1 = require("../config");
var browser;
var page;
beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, Browser_1.Browser.create({ url: config_1.CONFIG.testUrl + "login" })];
            case 1:
                browser = _a.sent();
                return [4, browser.currentPage()];
            case 2:
                page = _a.sent();
                return [2];
        }
    });
}); });
afterAll(function () { return browser.close(); });
describe("getDataValue", function () {
    test("returns null if data attribute not specified in config", function () { return __awaiter(void 0, void 0, void 0, function () {
        var dataAttribute;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        username.setAttribute("data-qa", "user");
                        var result = qawolf.locator.getDataValue(username, null);
                        username.removeAttribute("data-qa");
                        return result;
                    })];
                case 1:
                    dataAttribute = _a.sent();
                    expect(dataAttribute).toBeNull();
                    return [2];
            }
        });
    }); });
    test("returns null if element does not have specified data attribute", function () { return __awaiter(void 0, void 0, void 0, function () {
        var dataAttribute;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        username.setAttribute("data-other", "user");
                        var result = qawolf.locator.getDataValue(username, "data-qa");
                        username.removeAttribute("data-other");
                        return result;
                    })];
                case 1:
                    dataAttribute = _a.sent();
                    expect(dataAttribute).toBeNull();
                    return [2];
            }
        });
    }); });
    test("returns data attribute value correctly", function () { return __awaiter(void 0, void 0, void 0, function () {
        var dataAttribute;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        var username = document.getElementById("username");
                        username.setAttribute("data-qa", "user");
                        var result = qawolf.locator.getDataValue(username, "data-qa");
                        username.removeAttribute("data-qa");
                        return result;
                    })];
                case 1:
                    dataAttribute = _a.sent();
                    expect(dataAttribute).toBe("user");
                    return [2];
            }
        });
    }); });
});
test("getLabels correctly returns labels", function () { return __awaiter(void 0, void 0, void 0, function () {
    var nullLabels, usernameLabels;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, page.evaluate(function () {
                    var qawolf = window.qawolf;
                    return qawolf.locator.getLabels(document.getElementsByTagName("h2")[0]);
                })];
            case 1:
                nullLabels = _a.sent();
                expect(nullLabels).toBeNull();
                return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        return qawolf.locator.getLabels(document.getElementsByTagName("input")[0]);
                    })];
            case 2:
                usernameLabels = _a.sent();
                expect(usernameLabels).toEqual(["username"]);
                return [2];
        }
    });
}); });
test("getParentText correctly returns parent text", function () { return __awaiter(void 0, void 0, void 0, function () {
    var iconParentText;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, page.evaluate(function () {
                    var qawolf = window.qawolf;
                    return qawolf.locator.getParentText(document.getElementsByTagName("i")[0]);
                })];
            case 1:
                iconParentText = _a.sent();
                expect(iconParentText).toEqual([" login", " login"]);
                return [2];
        }
    });
}); });
test("getPlaceholder correctly returns placeholder", function () { return __awaiter(void 0, void 0, void 0, function () {
    var nullPlaceholder;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, page.evaluate(function () {
                    var qawolf = window.qawolf;
                    return qawolf.locator.getPlaceholder(document.getElementsByTagName("input")[0]);
                })];
            case 1:
                nullPlaceholder = _a.sent();
                expect(nullPlaceholder).toBeNull();
                return [2];
        }
    });
}); });
test("getTextContent correctly returns text content", function () { return __awaiter(void 0, void 0, void 0, function () {
    var headerTextContent, nullTextContent;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, page.evaluate(function () {
                    var qawolf = window.qawolf;
                    return qawolf.locator.getTextContent(document.getElementsByTagName("h2")[0]);
                })];
            case 1:
                headerTextContent = _a.sent();
                expect(headerTextContent).toBe("login page");
                return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        return qawolf.locator.getTextContent(document.getElementsByTagName("input")[0]);
                    })];
            case 2:
                nullTextContent = _a.sent();
                expect(nullTextContent).toBeNull();
                return [2];
        }
    });
}); });
test("getLocator correctly returns full element locator", function () { return __awaiter(void 0, void 0, void 0, function () {
    var inputLocator, headerLocator;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, page.evaluate(function () {
                    var qawolf = window.qawolf;
                    var username = document.getElementById("username");
                    username.setAttribute("data-qa", "user");
                    var result = qawolf.locator.getLocator(document.getElementsByTagName("input")[0], "data-qa");
                    username.removeAttribute("data-qa");
                    return result;
                })];
            case 1:
                inputLocator = _a.sent();
                expect(inputLocator).toMatchObject({
                    classList: null,
                    dataValue: "user",
                    href: null,
                    id: "username",
                    inputType: "text",
                    labels: ["username"],
                    name: "username",
                    placeholder: null,
                    tagName: "input",
                    textContent: null
                });
                expect(inputLocator.parentText).toContain("username");
                return [4, page.evaluate(function () {
                        var qawolf = window.qawolf;
                        return qawolf.locator.getLocator(document.getElementsByTagName("h2")[0], "data-qa");
                    })];
            case 2:
                headerLocator = _a.sent();
                expect(headerLocator).toMatchObject({
                    classList: null,
                    dataValue: null,
                    href: null,
                    id: null,
                    inputType: null,
                    labels: null,
                    name: null,
                    placeholder: null,
                    tagName: "h2",
                    textContent: "login page"
                });
                expect(headerLocator.parentText).toContain("login page");
                return [2];
        }
    });
}); });
//# sourceMappingURL=locator.test.js.map