"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findElementByXpath = function (xpath) {
    var result = document.evaluate(xpath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
    if (result.singleNodeValue) {
        return result.singleNodeValue;
    }
    return null;
};
var buildXpath = function (element) {
    if (!element || element.nodeType !== 1)
        return "";
    if (element.id)
        return "//*[@id='" + element.id + "']";
    var children = element.parentNode ? element.parentNode.children : [];
    var sames = [].filter.call(children, function (x) {
        return x.tagName === element.tagName;
    });
    var result = buildXpath(element.parentNode) +
        "/" +
        element.tagName.toLowerCase() +
        (sames.length > 1
            ? "[" + ([].indexOf.call(sames, element) + 1) + "]"
            : "");
    return result;
};
exports.getXpath = function (element) {
    var result = buildXpath(element);
    return result
        .replace("svg", "*[name()='svg']")
        .replace("path", "*[name()='path']");
};
exports.isXpathEqual = function (xpathA, xpathB) {
    if (!xpathA || !xpathB)
        return false;
    if (xpathA === xpathB)
        return true;
    var resolveSameElement = exports.findElementByXpath(xpathA) === exports.findElementByXpath(xpathB);
    return resolveSameElement;
};
//# sourceMappingURL=xpath.js.map